﻿using System;
using System.Threading;
using System.Windows.Input;

class Program
{
    static void Main(string[] args)
    {
        RelayCommand cmd = new RelayCommand();

        ConsolePrompt prompt = new ConsolePrompt();
        prompt.Command = cmd;
        prompt.Run();
    }
}

public class ConsolePrompt
{
    public ICommand Command
    {
        get; set;
    }

    public void Run()
    {
        _commandEnabled = Command.CanExecute(null);
        Command.CanExecuteChanged += Command_CanExecuteChanged;

        while (true)
        {
            string txt = Console.ReadLine();
            if (string.IsNullOrEmpty(txt) == true)
            {
                break;
            }

            if (_commandEnabled == true)
            {
                Command.Execute(txt);
            }
        }
    }

    bool _commandEnabled = false;

    private void Command_CanExecuteChanged(object sender, EventArgs e)
    {
        _commandEnabled = Command.CanExecute(null);
    }
}

public class RelayCommand : ICommand
{
    public event EventHandler CanExecuteChanged;

    public RelayCommand()
    {
        Thread t = new Thread((e) =>
        {
            RelayCommand cmd = e as RelayCommand;
            int old = DateTime.Now.Hour;

            while (true)
            {
                int current = DateTime.Now.Hour;

                if ((old == 8 && current == 9) || (old == 9 && current == 10))
                {
                    old = 10;
                    cmd.CanExecuteChanged(cmd, EventArgs.Empty);
                }

                old = current;

                Thread.Sleep(1000);
            }
        });

        t.IsBackground = true;
        t.Start(this);
    }

    public bool CanExecute(object parameter)
    {
        return DateTime.Now.Hour != 9;
    }

    public void Execute(object parameter)
    {
        Console.WriteLine(DateTime.Now + ": RelayCommand.Execute - " + parameter);
    }
}
