﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ICommand _clickCommand;
        public ICommand ClickCommand
        {
            get
            {
                if (_clickCommand == null)
                {
                    _clickCommand = new RelayCommand(this._txtBox);
                }

                return _clickCommand;
            }
        }

        public static readonly RoutedUICommand CopyCommand =
                new RoutedUICommand("MyCopy", "CopyFunc", typeof(MainWindow), null);

        public MainWindow()
        {
            InitializeComponent();
        }

        private void CopyCommand_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }

        private void CopyCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("RoutedUICommand.Execute called!");
        }
    }


    public class RelayCommand : ICommand
    {
        TextBox _target;

        public RelayCommand(TextBox txtBox)
        {
            _target = txtBox;
        }

        public event EventHandler CanExecuteChanged
        {
            add
            {
                CommandManager.RequerySuggested += value;
            }

            remove
            {
                CommandManager.RequerySuggested -= value;
            }
        }

        public bool CanExecute(object parameter)
        {
            return string.IsNullOrEmpty(_target.Text) == false;
        }

        public void Execute(object parameter)
        {
            MessageBox.Show("RelayCommand.Execute called!");
        }
    }
}
